'//FFSubmenu=Messen
'//FFName=RGB_Messkurve
'//FFPath=RGB_Messkurve.vbs
' 08.8.05 by O.S.

' Dieses Skript erzeugt eine Datei "Messkurve.jpg" im aktuellen Verzeichnis
' Es zeigt zwei aus dem aktuellen Bild ermittelten Gradationskurven,
' einmal auf Basis der Grau-Kontraste und
' einmal auf Basis der RGB-Kanle, jeweils getrennt fr die Kanle R, G und B.

' Voraussetzungen: 
' 1. Vorausgehender Aufruf von "RGB_Messkurve_Initialisieren"
' 2. Das Bild ist mindestens 1024 Pixel breit
'    Zur Zeit wird die Bildgre nicht geprft


Option explicit
Dim Bildname, Schriftart, AktuellerPfad
Dim r,g,b,x,y,y_inv,y_offset,aktRGB,aktRGB2
dim R_Messarray(),G_Messarray(),B_Messarray(),R_Streifen(),B_Streifen(),G_Streifen()
dim R2_Messarray(),G2_Messarray(),B2_Messarray(),Grau_Streifen()

' Initialisieren
'Arrays

Redim R_Messarray(255,255)
Redim G_Messarray(255,255)
Redim B_Messarray(255,255)
Redim R2_Messarray(255,255)
Redim G2_Messarray(255,255)
Redim B2_Messarray(255,255)
Redim R_Streifen(255)
Redim G_Streifen(255)
Redim B_Streifen(255)
Redim Grau_Streifen(255)

'Y-Koordinate, bei der die Werte gemessen werden
'Eigentlich wird nur ein 1-Pixel-hoher Verlauf bentigt, allerdings knnten Weichzeichner,
'LCE, Scharfzeichnung die Werte sonst strker beeinflussen
Y_offset = 10

' Bildnamen auslesen
Bildname=FF_GetImageName(-1)


'Vernderte Bilddaten aus den vier Streifen auslesen
For x=0 to 255
	R_Streifen(x) =  FF_GetPixel(x,    y_offset)  and 255
    G_Streifen(x) = (FF_GetPixel(x+256,y_offset)  \ 256) and 255 
    B_Streifen(x) = (FF_GetPixel(x+512,y_offset)  \ 65536) and 255 
    Grau_Streifen(x) = FF_GetPixel(x+768,y_offset) 
next

'Bild auf Originalmae beschneiden
FF_Crop 0,100,FF_GetImageWidth, FF_GetImageHeight-100  
'Bild in den Stack schieben
FF_PushImage
'Neues Bild fr die Darstellung der Messergebnisse erzeugen
FF_NewImage 522, 400, 0
' Beschreibenden Text erstellen  (funktioniert (noch?) nicht)
'FF_SetArea 0,0,0,0,false, false, 0
'FF_DrawText right(Bildname,10), 20, 100, 20, 0, 300, false, false, "Arial", rgb(240,240,240)
'FF_Reload

 
For x=0 to 255
  For y=0 to 255
  
	' Kurven berechnen
	' Die Berechnung beruht auf einem Vorschlag von Ralf Altmann
	' Hierbei werden bearbeitete und unbearbeiteter Verlauf um 90 Grad verdreht und die Pixelwerte subtrahiert

	y_inv=255-y
	r= Grau_Streifen(x) and 255 
	g=(Grau_Streifen(x) \ 256) and 255 
	b=(Grau_Streifen(x) \ 65536) and 255 

	R_Messarray(x,y) = 255-abs(R_Streifen(x)-y_inv)
	G_Messarray(x,y) = 255-abs(G_Streifen(x)-y_inv)
	B_Messarray(x,y) = 255-abs(B_Streifen(x)-y_inv)
	R2_Messarray(x,y) = 255-abs( r- y_inv)
	G2_Messarray(x,y) = 255-abs( g- y_inv)
	B2_Messarray(x,y) = 255-abs( b- y_inv)
	
	if R_Messarray(x,y) < 255 then 
   		R_MessArray(x,y) = 0
   		if (x=255-y or x=0 or x=64 or x=128 or x=192 or x=255 or y=0 or y=64 or y=128 or y=192 or y=255) then R_MessArray(x,y)=80
	end if
	if G_Messarray(x,y) < 255 then 
   		G_MessArray(x,y) = 0
   		if (x=255-y or x=0 or x=64 or x=128 or x=192 or x=255 or y=0 or y=64 or y=128 or y=192 or y=255) then G_MessArray(x,y)=80
	end if
	if B_Messarray(x,y) < 255 then 
   		B_MessArray(x,y) = 0
   		if (x=255-y or x=0 or x=64 or x=128 or x=192 or x=255 or y=0 or y=64 or y=128 or y=192 or y=255) then B_MessArray(x,y)=80
	end if
	
	if R2_Messarray(x,y) < 255 then 
   		R2_MessArray(x,y) = 0
   		if (x=255-y or x=0 or x=64 or x=128 or x=192 or x=255 or y=0 or y=64 or y=128 or y=192 or y=255) then R2_MessArray(x,y)=80
	end if
	if G2_Messarray(x,y) < 255 then 
   		G2_MessArray(x,y) = 0
   		if (x=255-y or x=0 or x=64 or x=128 or x=192 or x=255 or y=0 or y=64 or y=128 or y=192 or y=255) then G2_MessArray(x,y)=80
	end if
	if B2_Messarray(x,y) < 255 then 
   		B2_MessArray(x,y) = 0
   		if (x=255-y or x=0 or x=64 or x=128 or x=192 or x=255 or y=0 or y=64 or y=128 or y=192 or y=255) then B2_MessArray(x,y)=80
	end if
  
  next
next

' Erzeugen der beiden Messkurven
for y=0 to 255 
	for x=0 to 255 
		'aktRGB = R_MessArray(x,y) * 65536 + G_MessArray(x,y) * 256 + B_MessArray(x,y)
		aktRGB = rgb(R_MessArray(x,y),G_MessArray(x,y),B_MessArray(x,y))
		FF_SetPixel x+265,y,aktRGB 
  		aktRGB2 = rgb(R2_MessArray(x,y),G2_MessArray(x,y),B2_MessArray(x,y))
  		FF_SetPixel x,y,aktRGB2 
 next 
 FF_SetProgress y,254 
next 


' Erstellt zustzlich zu den Messkurven noch vorher-nachher-Farbverlufe
for x=0 to 255    
	aktRGB = rgb(R_Streifen(x),G_Streifen(x),B_Streifen(x))
	aktRGB2 = Grau_Streifen(x)
	for y=0 to 19
		
		'Linke Seite: Grau
	    FF_SetPixel x,y+265,rgb(x,x,x)
		FF_SetPixel x,y+265+20,Grau_Streifen(x) 
  		
  		'Rechte Seite: Rot, Grn, Blau
	    FF_SetPixel x+265,y+265,x 
		FF_SetPixel x+265,y+265+20,R_Streifen(x)  
	    
	    FF_SetPixel x+265,y+265+45,x * 256 
		FF_SetPixel x+265,y+265+65,G_Streifen(x) * 256 
	    
	    FF_SetPixel x+265,y+265+90,x * 65536
		FF_SetPixel x+265,y+265+110,B_Streifen(x) * 65536
    next
      
next






'Zeigt die Messkurven in einem zweiten Fenster an
FF_ShowImage

AktuellerPfad=FF_GetImagePath
'OnError AktuellerPfad="c:\temp\"
msgbox "Die Messkurven werden im aktuellen Verzeichnis: " & AktuellerPfad & "\Messkurve.jpg" & " gespeichert."
FF_SaveImage AktuellerPfad & "\Messkurve.jpg",0
FF_Popimage
FF_Reload


